/*----------------------------------------------------------------------------------------------
Program: Java uWѫ Client 
Author: |, h
Number: 8834002, 8834042
Version: 2.0
Date: 2003/6/3
----------------------------------------------------------------------------------------------*/
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

/*
<APPLET CODE = ClientInterface.class WIDTH = 900 HEIGHT = 600><PARAM NAME = server VALUE = "140.117.201.36"></APPLET>
*/

public class ClientInterface extends JApplet implements ActionListener {
    
	private JLabel jlUserID;
	private JTextField SystemState;
	private JMenu fileMenu, serverMenu;
	private JMenuItem exitMItem, linkItem;
	private JMenuBar bar;
	private JPanel loginPanel, SouthPanel, WestPanel, EastPanel, Client_View;
	private JButton SendMessage, emoButton [];
	private JComboBox msgFont, msgSize, msgColor;
 	private String transFont, transSize; // the message's font, size and color
        private int transColor, transEmo;
	
        public CardLayout cardlayout;
	public Container contentPane;
	public String ServerIP, UserID;		// AIp, ϥΪID
	public static JList UserList;
	public static String AllUser [] = new String[21];
	public static JTextPane TalkArea;
	public JTextField InputMessage;
	public static JTextField userid;
	public DataInputStream dis;
	public DataOutputStream dos;
	public listener listen;
 	public static JScrollPane jscrollpane;        	
	public static JViewport jviewport;     	

	public void init() {	    	   
                		
	    try {	        
		Socket socket = new Socket(getParameter("server"), 8888);
			
		InputStream is = socket.getInputStream();
		dis = new DataInputStream(is);		
		OutputStream os = socket.getOutputStream();
		dos = new DataOutputStream(os);				
		
		contentPane = getContentPane();			
		cardlayout = new CardLayout();//إߦhh
		contentPane.setLayout(cardlayout);		

                loginPanel = new JPanel();
		jlUserID = new JLabel( "JAW١G" );
		userid = new JTextField(24);   
                userid.addActionListener(this);		             
                Client_View = new JPanel();

		loginPanel.add(jlUserID);
		loginPanel.add(userid);				

		contentPane.add("login", loginPanel);//إߵnJePanel
		contentPane.add("main", Client_View);//إߥDePanel			
		
		Client_View.setLayout( new BorderLayout() );

		WestPanel = new JPanel();
		WestPanel.setLayout ( new BorderLayout(1,1) );
		EastPanel = new JPanel();
		EastPanel.setLayout( new GridLayout(9,3) );		
		SouthPanel = new JPanel();
		SouthPanel.setLayout( new FlowLayout() );

		// User List
		AllUser[0] = "All";
		UserList = new JList();
		UserList.setListData(AllUser);
		UserList.setSelectedIndex( 0 );
		UserList.setFixedCellHeight( 25 );
		UserList.setFixedCellWidth( 30 );
		WestPanel.add( UserList, BorderLayout.NORTH );

		// message's font
		final String FontContent[] = { "Arial", "з", "ө", "Courier" , "Dotum", "Serif"};
		msgFont = new JComboBox( FontContent );
		msgFont.setSelectedIndex(2);
		msgFont.addItemListener(
			new ItemListener()
			{
				public void itemStateChanged( ItemEvent event )
				{
					// ]wǰer
					if ( event.getStateChange() == ItemEvent.SELECTED )
					{
						transFont = FontContent[ msgFont.getSelectedIndex() ];
                                                TalkArea.setFont(new Font(transFont, Font.PLAIN, Integer.parseInt(transSize)));
					}
				}
			}
		);

		WestPanel.add( msgFont, BorderLayout.WEST );

		// message's size
		final String SizeContent[] = { "6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30"};
		msgSize = new JComboBox( SizeContent );
		msgSize.setSelectedIndex(6);
		msgSize.addItemListener(
			new ItemListener()
			{
				public void itemStateChanged( ItemEvent event )
				{
					if ( event.getStateChange() == ItemEvent.SELECTED )
					{
						transSize = SizeContent[ msgSize.getSelectedIndex() ];
                                                TalkArea.setFont(new Font(transFont, Font.PLAIN, Integer.parseInt(transSize)));						
					}
				}
			}
		);

		WestPanel.add( msgSize, BorderLayout.CENTER );

		// message's color
		final String ColorContent[] = { "black", "blue", "red", "green", "orange", "yellow", "gray", "pink"};
		msgColor = new JComboBox( ColorContent );
		msgColor.setSelectedIndex(0);
		//transColor = 0;
		msgColor.addItemListener(
			new ItemListener()
			{
				public void itemStateChanged( ItemEvent event )
				{
					if ( event.getStateChange() == ItemEvent.SELECTED )
					{
						transColor = msgColor.getSelectedIndex();
					}

				}
			}
		);

		WestPanel.add( msgColor, BorderLayout.EAST );

		// message's emotion
        	try {
		    emoButton = new JButton[27];
		    for (int i=0;i<27;i++) {		    	
			emoButton[i] = new JButton(new ImageIcon(getClass().getResource("emotion/" + (i+1) + ".gif")));
			emoButton[i].addActionListener(this);
			EastPanel.add( emoButton[i] );
		    }
	        } catch(Exception e) {}	

		// Talk Area
		TalkArea = new JTextPane();
		TalkArea.setEditable(false);
		jscrollpane = new JScrollPane(TalkArea);		
		
		// Input Message
		InputMessage = new JTextField(50);		
		InputMessage.addActionListener( this );
		SendMessage = new JButton( "eX" );
		SendMessage.addActionListener( this );
		SouthPanel.add( InputMessage );
		SouthPanel.add( SendMessage );
		
		Client_View.add( WestPanel, BorderLayout.WEST );
		Client_View.add( jscrollpane, BorderLayout.CENTER );		
		Client_View.add( EastPanel, BorderLayout.EAST );      
		Client_View.add( SouthPanel, BorderLayout.SOUTH );
		cardlayout.show(contentPane, "login");
		
	    } catch(Exception e) {	  	
		  contentPane.setLayout(new BorderLayout());
	 	  contentPane.add("Center",new JLabel("sW ChatServer,i Server SҰ!",JLabel.CENTER));
		}

	}

	public void destroy() {
	  try {	
		dos.writeUTF("L" + UserID); //Client}ѫ
	  }
	  catch(IOException e){}
	}
	
	public void actionPerformed( ActionEvent event )
	{	
		// User come into the room
		if( event.getSource() == userid ) 
		{
		    try	{	
	  			cardlayout.show(contentPane, "main");
	  			UserID = userid.getText();
				listen = new listener(dis, TalkArea);
				dos.writeUTF( "N" + UserID ); //VServereXsiJѫǪT
				dos.writeUTF( "w" + UserID); //d߲ѫǦ
			}
			catch(IOException e){}
		}    	
		
		// eXT...
		if ( event.getSource() == SendMessage || event.getSource() == InputMessage )
		{
			// VҦHǰT...

			if ( AllUser[ UserList.getSelectedIndex() ] == "All" )
			{
				try
				{
					dos.writeUTF( "M " + transColor + " <" + UserID + ">" + InputMessage.getText() );
					InputMessage.setText("");
				}
				catch ( IOException e ) {}
			}
			// VYӤHǰT...ܶǰTHGAllUser[ UserList.getSelectIndex() ]
			else
			{
				try
				{
					dos.writeUTF( "m " + UserID + " " + AllUser[ UserList.getSelectedIndex() ] + " " + transColor + " " + InputMessage.getText() );
				        InputMessage.setText("");
				}
				catch ( IOException e ) {}
			}
		}

		// emotion message
		for (int i = 1; i <= emoButton.length; i++ )
		{
			if ( event.getSource() == emoButton[i-1] )
			{
				InputMessage.setText( InputMessage.getText() + "<<" + i + ">>" );
			}
		}

	}
}

class listener extends Thread {
    
    protected int startChar, i, j;;
    protected String msg, wordColor, tmpmsg1, tmpmsg2, emoSymbol;
    protected StringTokenizer st;
    public Object attribColor [];    
    DataInputStream dis;
    JTextPane output;
    public static int online;
    public Point position;					    

    listener(DataInputStream dis, JTextPane output) {
        this.dis = dis;
	this.output = output;
	ClientInterface.jviewport = ClientInterface.jscrollpane.getViewport();
	//Cݩ
        attribColor = new Object [8];	
        SimpleAttributeSet black = new SimpleAttributeSet();
        StyleConstants.setForeground(black, Color.black);		    	
        attribColor[0] = black;
        SimpleAttributeSet blue = new SimpleAttributeSet();            
        StyleConstants.setForeground(blue, Color.blue);		   
        attribColor[1] = blue;
        SimpleAttributeSet red = new SimpleAttributeSet();                         	        	
        StyleConstants.setForeground(red, Color.red);	        
        attribColor[2] = red;
        SimpleAttributeSet green = new SimpleAttributeSet();                         	        	
        StyleConstants.setForeground(green, Color.green);	        
        attribColor[3] = green;
        SimpleAttributeSet orange = new SimpleAttributeSet();                         	        	
        StyleConstants.setForeground(orange, Color.orange);	        
        attribColor[4] = orange;
        SimpleAttributeSet yellow = new SimpleAttributeSet();                         	        	
        StyleConstants.setForeground(yellow, Color.yellow);	        
        attribColor[5] = yellow;
        SimpleAttributeSet gray = new SimpleAttributeSet();                         	        	
        StyleConstants.setForeground(gray, Color.gray);	        
        attribColor[6] = gray;
        SimpleAttributeSet pink = new SimpleAttributeSet();                         	        	
        StyleConstants.setForeground(pink, Color.pink);	        
        attribColor[7] = pink;        
	this.start();
    }

  	public void run() {
        	
	try {
	    while(true) {
	  	msg = dis.readUTF();
	  	
	  	if(msg != null) {
	  	    
	  	    switch(msg.charAt(0)) {
	  	        
		        case 'w':
			    st = new StringTokenizer(msg);

			    // MAllUser ListeAud All oUserK
			    for ( i = 1; i <=SETTING.DEFAULT_NUM; i++ ) {
			        ClientInterface.AllUser[i] = "";
			    }

			    // ANdߨ쪺ҦUser[ AllUser List ArrayK
			    ClientInterface.AllUser[1] = st.nextToken().substring(1);
			    for ( i = 2; i <=SETTING.DEFAULT_NUM; i++ ) {			
			        
			        if ( st.hasMoreTokens() ) {				
				    ClientInterface.AllUser[i] = st.nextToken();
				}
				else {				
				    break;
				}
			    }

			    // ̫AN AllUser List ArraywList UserListK
			    ClientInterface.UserList.setListData(ClientInterface.AllUser);
	  		    break;

			case 'M':
			    st = new StringTokenizer(msg);
			    st.nextToken();
			    wordColor = st.nextToken();
//ϥ
//]LkqϥX....			  
				tmpmsg1 = new String( msg.substring(wordColor.length() + 3) );
				tmpmsg2 = new String();
				emoSymbol = new String();

					// startChar is the pointer point to the start of msg array
					startChar = 0;
					
					// check all the chars of the msg order to find '<'
					for ( i = 0; i < tmpmsg1.length(); i++ )
					{
						// find the '<<' and display the msg before the '<<' chars
						if ( (tmpmsg1.charAt(i) == '<') && (tmpmsg1.charAt(i+1) == '<') )
						{
							// accord the startChar & countChar display the msg
							tmpmsg2 = tmpmsg1.substring( startChar, i );
							append( tmpmsg2, (SimpleAttributeSet) attribColor[Integer.parseInt(wordColor)] );

							// find the emotion type and display it
							for ( j = i + 2; ; j++ )
							{
								if ( (tmpmsg1.charAt(j) == '>') && tmpmsg1.charAt(j+1) == '>')
								{
									emoSymbol = tmpmsg1.substring( i + 2, j );
									break;
								}
							}

							// append the emotion image onto the TalkArea
							output.setSelectionStart( output.getDocument().getLength());							
							output.insertIcon(new ImageIcon(getClass().getResource( "emotion/" + emoSymbol + ".gif")));

							i = j + 1;
							startChar = i + 1;
						}
					}

					// show the message leave
					if ( startChar != i )
					{
						tmpmsg2 = tmpmsg1.substring( startChar );
						append( tmpmsg2, (SimpleAttributeSet) attribColor[Integer.parseInt(wordColor)] );
					}

					append( "\n", null );

			    position = ClientInterface.jviewport.getViewPosition();			    
			    if (position.y >= 50) {
			    	position.y += 20;
			    	ClientInterface.jviewport.setViewPosition(position);					    
			    }	
			    break;
			    
			case 'm':
	                    append(msg.substring(1) + "\n", null);
			    position = ClientInterface.jviewport.getViewPosition();			    
			    if (position.y >= 50) {
			    	position.y += 20;
			    	ClientInterface.jviewport.setViewPosition(position);					    
			    }		                    
                            break;
	            }
                }
	    }
        } catch(IOException e) {}
    }

	// add component to TalkArea(JTextPane)
	protected void append(String s, AttributeSet attributes) {
	    Document d = output.getDocument();
	    try {
		d.insertString(d.getLength(), s, attributes);
	    } catch (BadLocationException ble) {}
	}

}
