/*----------------------------------------------------------------------------------------------
Program: Java uWѫ Server 
Author: |
Number: 8834002
Version: 1.0
Date: 2001/6/11
----------------------------------------------------------------------------------------------*/
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;

interface SETTING
{
public final int DEFAULT_PORT = 8888;//]wport
public final int DEFAULT_NUM = 20;//]wWH
}

class server extends Thread implements SETTING
{
	public static ServerSocket listen_socket;
	public static Socket userhost [] = new Socket[DEFAULT_NUM];//}Socket}CUClientSocket
	public static String userID [] = new String[DEFAULT_NUM];//}String}CUClientID
	public static int online = 0;//]wuWH
	public static ServerInterface SI_View = new ServerInterface();	//}Server
	
  	static //tOmUID}C
  	{
            for(int i=0;i<DEFAULT_NUM;i++) {
    	        userID[i] = new String();
    	    }
	}

	server()
	{
		SI_View.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		try {
			listen_socket = new ServerSocket(DEFAULT_PORT);
			SI_View.JTA_ServerState.append( "Server is running.\n" );
			SI_View.jtfCount.setText( "0" );
		}
		catch(Exception e) {}		
 	  	
 	  	this.start();
	}
	
	public void run()//Main Thread Ұ
	{
		int i;
		String tmp;

	  try{
	  	while(true)
	  	{
	  		Socket client_socket = listen_socket.accept();//ťSocket
	  		
	  		for(i=0;i<DEFAULT_NUM;i++)//t@ӦmClient
	  		{	  			
	  			if(userhost[i] == null)
	  			{
					SI_View.JTA_ServerState.append( "Socket " + i + " is running.\n" );
	  				++server.online;
	  				userhost[i] = client_socket;
					SI_View.jtfCount.setText( server.online  + "");
					break;
	  			}	  				  			
	  		}
	  		
	  		ChatConnection c = new ChatConnection(client_socket, i);//ChatConnection Thread	  			  			  			  			  		
	  	}	
	  }
	  catch(Exception e){}		
	}	

	public static void main(String[] args)//Main Programe
	{
		new server();//server Thread
	}
}

class ChatConnection extends Thread implements SETTING {
    
    protected Socket client;
    protected DataInputStream dis;
    protected DataOutputStream dos;
    protected String msg, from, towho, forwhat, wordColor;
    protected StringTokenizer st;     
    int hostid = 0;	
	
    ChatConnection(Socket client_socket, int hostid) {
        
    this.hostid = hostid;
    this.client = client_socket;
		
    try {
	InputStream is = client.getInputStream();
	dis = new DataInputStream(is);
    } catch(IOException e) {
          try {
	      client.close();
          } catch(Exception ee) {}
      }
      
    this.start();
    }	
	
    public void sendTo(String userid, String szMsg) {//Point to Point ǰT
		
        for(int i=0;i<DEFAULT_NUM;i++) {//useridӧP_䬰@Client
		
	    if(server.userhost[i] != null) {			  
	        
	        if(server.userID[i].equals(userid)) {				
		    try {	
		        OutputStream os = server.userhost[i].getOutputStream();        		  	
       			dos = new DataOutputStream(os);
       			dos.writeUTF(szMsg);       
       			break;								  		
       		    } catch(IOException e) {}
		}
	    }	
	}				
    }


    public void sendToAllHost(String szMsg) {//BroadCast ǰT
    		
        for(int i=0;i<DEFAULT_NUM;i++) {//ǰeUӳsClient
 
     	    if(server.userhost[i] != null ) {
       	        try {     
                    //System.out.println("host["+i+"]->send");        		  	        		  	   		
		    OutputStream os = server.userhost[i].getOutputStream();        		  	
       		    dos = new DataOutputStream(os);
       		    dos.writeUTF(szMsg);       			
       		    dos.writeUTF("O"+Integer.toString(server.online));
                } catch(IOException e) {//ҥ~Bz...|ץ...
                      //server.userhost[i] = null;
       		      //--server.online;
       		      System.out.println("Exception5:"+e);
                  }
            }
	}
    }		       			
		
    public void run() {//ChatConnection Thread Ұ        
        int i;
        			
	try {
            while(true) {	  		
	        msg = dis.readUTF();
		if(msg == null) break;

		switch(msg.charAt(0)) {//qClientݶǰeƧP_command
				
		    case 'w'://d߲ѫǦ
		        StringBuffer buffer = new StringBuffer();

			for(i=0;i<DEFAULT_NUM;i++) {//jMUCleintݬO_s
			
			    if(server.userhost[i] != null) {
			        buffer.append(server.userID[i] + " ");//NuseridǤJmsgbuffer
			    }
			}
			sendToAllHost( "w" + buffer.toString() ); //iҦClientݥثeҦUserID
			break;
					
		    case 'm': //ǰTSwClient
			st = new StringTokenizer(msg);
			st.nextToken();
			from = st.nextToken();
			towho = st.nextToken();
			wordColor = st.nextToken();
			for(i=0;i<DEFAULT_NUM;i++) {//useid
			    
			    if(server.userID[i].equals(towho)) {
			        forwhat =  wordColor + " <" + from + "> A: " + msg.substring(from.length() + towho.length() + wordColor.length() + 5);	  			  		
				sendTo(from, "M " + wordColor + " A " + towho + " :" + msg.substring(from.length() + towho.length() + wordColor.length() + 5));
				sendTo(towho, "M " + forwhat);
				break;
			    }
			    else {						
			        if(i == DEFAULT_NUM - 1)//LID
				sendTo(from, "m*** LϥΪ ***");
			    }
			}
			break;

                    case 'N'://sϥΪ̶iJѫ
			server.userID[hostid] = new String(msg.substring(1));
			sendToAllHost("m[" + msg.substring(1) + "]iJѫ"); //iҦClientݦsUser[JK
			server.SI_View.JTA_ServerState.append( "[" + msg.substring(1) + "] come to the room...\n"); //ܨϥΪ̶iJѫ...
			break;

		    case 'M'://BroadCastUClient
			sendToAllHost(msg);
			break;

		    case 'L': //ϥΪ}ѫ

					for( i = 0; i < DEFAULT_NUM; i++ )
					{
						if( server.userhost[i] != null )
						if(server.userID[i].equals(msg.substring(1))) //reset useridSocket}C
						{
							server.userID[i] = null;
							server.userhost[i] = null;
							--server.online;
							server.SI_View.JTA_ServerState.append( "[" + msg.substring(1) + "] leave the room...\n");
							server.SI_View.jtfCount.setText( server.online + "" );
							break;
							}
					}
					sendToAllHost("m["+msg.substring(1)+"]}ѫ"); //eXClient}ѫǪT

					// UpdateҦClientuWH
					StringBuffer buffer2 = new StringBuffer();
					for(i=0;i<DEFAULT_NUM;i++) //jMUCleintݬO_s
					{
						if(server.userhost[i] != null)
						{
							buffer2.append(server.userID[i] + " "); //NuseridǤJmsgbuffer
						}
					}
					sendToAllHost( "w" + buffer2.toString() ); //iҦClientݥثeҦUserID
					break;
	  	}	  		  		  			  		
            }	  	  	  
        } catch(IOException e) {
              System.out.println("Exception6:"+e);
	  }				
	  
	finally {
	    try {	
	  	client.close();
	    } catch(Exception e){}		  	
        }
    }
}